VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "xlupgrade"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "Upgrade any excel file to the latest version of Excel"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Public Function upgrade(ByRef sfilename() As String) As Integer
Attribute upgrade.VB_Description = "Upgrade an XL file to latest version"

Dim xlApp As Excel.Application
Dim i As Integer, max As Integer
Dim sTmpName As String
Dim fs

On Error GoTo ERR_HANDLER
   
    Set xlApp = New Excel.Application
    
    max = UBound(sfilename) - 1
    If max = 0 Then
        upgrade = 0
        Exit Function
    End If
    
    'Create file system object for file operations
    Set fs = CreateObject("Scripting.FileSystemObject")
    
    Screen.MousePointer = vbHourglass
    'Loop thru for each file passed in the array
    For i = 0 To max
        'Create a tmp File Name
        sTmpName = "C:\temp\" & fs.GetFileName(sfilename(i))
        'Copy the File to Temp Location
        fs.CopyFile sfilename(i), sTmpName
        'Delete original File
        fs.DeleteFile sfilename(i), True
        'Open Tmp File
        xlApp.Workbooks.Open filename:=sTmpName
        
        'Write to Original lcoation
        xlApp.ActiveWorkbook.SaveAs filename:=sfilename(i), FileFormat:=xlNormal, _
            Password:="", WriteResPassword:="", ReadOnlyRecommended:=False, _
            CreateBackup:=False
        'Close Workbook
        xlApp.Workbooks.Close
        'Delete Tmp File
        fs.DeleteFile sTmpName, True
    Next    'Loop for next file
    
    xlApp.Quit
    
    Set xlApp = Nothing
    Set fs = Nothing
    
    Screen.MousePointer = vbDefault
    MsgBox "Excel Files upgraded."
    
    upgrade = 1     'success

Exit Function
    
ERR_HANDLER:
    Screen.MousePointer = vbDefault
    xlApp.Quit
   Set xlApp = Nothing
   Set fs = Nothing
   MsgBox Err.Description, , App.ProductName
   upgrade = -1
   
End Function

